{-
   Functional Programming Competition Entry
   
   Written by
   Dimo Petroff, 0907904
   
   To see a nice "Burning Ship" fractal, 
   load in GHCi and type main if it doesn't run automatically
-}

--though not realy an L-System, the burning ship needs the turtle graphics that are in the LSystem.hs file
import LSystem

--don't change these or you'll brake the turtle graphics... or OpenGL...
--well, you'll definately get a smaller image or longer render time,
--or no image at all if you change these, so something definately gets broken.
maxit :: Int
maxit=250
imgsize :: Int
imgsize = 300

--change these to get different views on the ship. dcx and dcy are the x and y coordinates for the center of the image. dxy is zoom
dcx :: Float
dcx=1.625
dcy :: Float
dcy=0.02
dxy :: Float
dxy=0.05

--this calculates every pixel of the image as turtle graphics commands
render :: Int -> Float -> Float -> Float -> [[Command]]
render s dcx dcy dxy = pix s
	where
	pix y	| y==0		= [[]]
			| otherwise	= line s y : pix (y-1)
		where
		line x y	| x==0		= []
					| otherwise	= (compute 0 0 0 cx cy):line (x-1) y
			where
			cx = dcx + (fromIntegral(imgsize - x) - (fromIntegral imgsize)/2)*dxy/(fromIntegral imgsize)
			cy = dcy + (fromIntegral(imgsize - y) - (fromIntegral imgsize)/2)*dxy/(fromIntegral imgsize)

--this calculates the color for a pixel
compute :: Float -> Float -> Int -> Float -> Float -> Command
compute x y i cx cy | i<maxit && (x*x + y*y < 201)	= compute (x*x - y*y - cx) (2*abs(x*y) - cy) (i+1) cx cy
					| otherwise						= (GrabPen (Colour ((fromIntegral i)/(fromIntegral maxit)) ((fromIntegral i)/(fromIntegral maxit)) ((fromIntegral i)/(fromIntegral maxit)))) :#: Go 0.1
					
--this converts the output of render to a single command
makepic :: [[Command]] -> Command
makepic [] = Sit
makepic (x:xs)	= Branch (Turn (-90) :#: (foldl (:#:) Sit x)) :#: Branch (Go 0.1 :#: makepic xs)

--this does everything that needs to be done in order to bring the burning ship fractal to your screen... it's awesome.
main :: IO ()
main = display (makepic (render imgsize dcx dcy dxy)) 
		
